from MuLexer import MuLexer
from MuParser import MuParser
from MuVisitor import MuVisitor
from MyMuVisitor import MyMuVisitor
from MyMuTypingVisitor import MyMuTypingVisitor

import argparse
import sys

import antlr4

def main():
    parser = argparse.ArgumentParser(description='Compile mu files.')
    parser.add_argument('path', type=str,
                        help='file to compile')
    args = parser.parse_args()

    input_s = antlr4.FileStream(args.path)
    lexer = MuLexer(input_s)
    stream = antlr4.CommonTokenStream(lexer)
    parser = MuParser(stream)
    tree = parser.prog()

    print("Parsed.")
    #typing Visitor
    visitor1 = MyMuTypingVisitor();
    visitor1.visit(tree);
    print("Typed.")
    
    #eval Visitor
    visitor2 = MyMuVisitor();
    visitor2.visit(tree);
    print("Evaluated.")
    
if __name__ == '__main__':
    main()

